/*01 / 09 / 2008*/

/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License .
Created by Dev-C++ 5 Beta version 4.9.9.2 
codename:DR-G-2
DR's Noughts & Crosses beta v1.6 for Windows.
*/

#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>

int Quit = 0, x, y,
Round , Pos = 0, Count, Count_2 ;
int X_Set[3][3], O_Set[3][3] ;
int Player_Set[9], AI_Set[9];
int Space[9] ;
int Game_Mode ;
int Final_Result = 0 ;
int Lock ;
int First_Blood, Second_Blood, Last_Set ;

SDL_Surface *Screen ;
SDL_Surface *BackGround ;
SDL_Surface *O, *X, *Line, *Line_Vert, *Line19, *Line37 ;
SDL_Rect dest ;
SDL_Event Event ;

Uint32 Colorkey ;

int main(int argc, char *argv[])
{
 if (argv[1]!= 0 )
   {
     if (strcmp ( argv[1], "--cf" ) == 0 )
     {
       Game_Mode = 1 ;
     }
     if (strcmp ( argv[1], "--ca" ) == 0 )
     {
       Game_Mode = 2 ;
     }
   }
 else
   {
     Game_Mode = 0 ;
   }
 SDL_Init( SDL_INIT_VIDEO ) ;
 
 BackGround = SDL_LoadBMP("image/bg.bmp") ;
 if ( BackGround == NULL )
     Quit = 1 ;
 O = SDL_LoadBMP("image/o.bmp") ;
 if ( O == NULL )
     Quit = 1 ;
 X = SDL_LoadBMP("image/x.bmp") ;
 if ( X == NULL )
     Quit = 1 ; 
 Line = SDL_LoadBMP("image/line.bmp") ;
 if ( Line == NULL )
     Quit = 1 ;
 Line_Vert = SDL_LoadBMP("image/line_vert.bmp") ;
 if ( Line_Vert == NULL )
     Quit = 1 ;
 Line19 = SDL_LoadBMP("image/line19.bmp") ;
 if ( Line19 == NULL )
     Quit = 1 ;
 Line37 = SDL_LoadBMP("image/line37.bmp") ;
 if ( Line37 == NULL )
     Quit = 1 ;
 
 if ( Quit == 1 )
   {
     printf ( "Unable to load bitmap, abort.\n") ;
   }
 else
   { 
     start_up();
     Lock = 0 ;
 
     if ( Game_Mode == 1 )
       {
         Pos = ai() ;
         AI_Set[Pos-1] = 1 ;
         printf("AI = %d\n",Pos);
         game_main() ;
       }
   }

 /* Game loop. */
  while( Quit == 0 )
    {
      while( SDL_PollEvent( &Event ) )
        {
              if( Event.type == SDL_MOUSEBUTTONDOWN ||
                  Event.type == SDL_KEYUP ) 
                { 
                  if( ( Event.button.button == SDL_BUTTON_LEFT ||
                        Event.key.keysym.sym == SDLK_KP1 ||
                        Event.key.keysym.sym == SDLK_KP2 ||
                        Event.key.keysym.sym == SDLK_KP3 ||
                        Event.key.keysym.sym == SDLK_KP4 ||
                        Event.key.keysym.sym == SDLK_KP5 ||
                        Event.key.keysym.sym == SDLK_KP6 ||
                        Event.key.keysym.sym == SDLK_KP7 ||
                        Event.key.keysym.sym == SDLK_KP8 ||
                        Event.key.keysym.sym == SDLK_KP9 )
                      && Lock == 0 ) 
                    {
                      Lock = 1 ;
                      if ( Event.type == SDL_MOUSEBUTTONDOWN )
                        {
                          x = Event.button.x ; 
                          y = Event.button.y ;
                        }
                      else
                        {
                          x = 0 ;
                          y = 0 ;
                        }
                      
                      if ( Final_Result != 0 || Round > 9 )
                        {
                          start_up();
                          if ( Game_Mode == 1 )
                          {
                            Pos = ai() ;
                            AI_Set[Pos-1] = 1 ;
                            printf("AI = %d\n",Pos);
                            game_main() ;
                          }                       
                        }
                      else
                        {
                          if ( Game_Mode == 0 )
                            {
                              Pos = player();
                              game_main() ;
                            }
                          else
                            {
                              Pos = player() ;
                              
                              if ( Space[Pos-1] != 1 )
                                {
                                  Player_Set[Pos-1] = 1 ;
                                  printf("Player = %d\n",Pos);              
                                  game_main() ;
                                    if ( Final_Result == 0 && Round <= 9 )
                                      {
                                        Pos = ai() ;
                                        AI_Set[Pos-1] = 1 ;
                                        printf("AI = %d\n",Pos);
                                        game_main() ;
                                      }
                                    else
                                      {   
                                        if ( Final_Result == 0 && Game_Mode == 1 )
                                          {
                                            Pos = ai() ;
                                            AI_Set[Pos-1] = 1 ;
                                            printf("AI = %d\n",Pos);
                                            game_main() ;
                                          }
                                      }
                                }
                            } 
                        }
                      Lock = 0 ;                   
                    }
                }
          
          /* Shutdown loop. */
          if( Event.type == SDL_QUIT )
            {
              Quit = 1 ;
            }    
        }
    }
  
 /* Quit. */  
 SDL_FreeSurface ( BackGround ) ;
 SDL_FreeSurface ( O ) ;
 SDL_FreeSurface ( X ) ;
 SDL_FreeSurface ( Line ) ;
 SDL_FreeSurface ( Line_Vert ) ;
 SDL_FreeSurface ( Line19 ) ;
 SDL_FreeSurface ( Line37 ) ;
 atexit( SDL_Quit ) ;
 return 0 ;
}

int game_main()
{
 
 if ( Space[Pos-1] != 1 )
   { 
     if ( Round % 2 != 0 )
       {
         SDL_BlitSurface ( O, 0, Screen, &dest ) ;
         archive ( 0 ) ;
       }
     else
       {
         SDL_BlitSurface ( X, 0, Screen, &dest ) ;      
         archive ( 1 ) ;             
       }
                  
     SDL_UpdateRect( Screen, 0, 0, 0, 0 ) ;
                          
     if ( ( Final_Result = result() ) != 0 )
       {
         Colorkey = SDL_MapRGB ( Line->format, 255, 255, 255 );
         if ( Final_Result == 1 || Final_Result == 5 )
          {          
            SDL_SetColorKey ( Line, SDL_SRCCOLORKEY, Colorkey ) ;
            SDL_BlitSurface ( Line, 0, Screen, &dest ) ;
          }
         if ( Final_Result == 2 || Final_Result == 6 )
           {          
             SDL_SetColorKey ( Line_Vert, SDL_SRCCOLORKEY, Colorkey ) ;
             SDL_BlitSurface ( Line_Vert, 0, Screen, &dest ) ;
           }
         if ( Final_Result == 3 || Final_Result == 7 )
           {          
             SDL_SetColorKey ( Line19, SDL_SRCCOLORKEY, Colorkey ) ;
             SDL_BlitSurface ( Line19, 0, Screen, &dest ) ;
           }
         if ( Final_Result == 4 || Final_Result == 8 )
           {          
             SDL_SetColorKey ( Line37, SDL_SRCCOLORKEY, Colorkey ) ;
             SDL_BlitSurface ( Line37, 0, Screen, &dest ) ;
           }
                                
         SDL_UpdateRect( Screen, 0, 0, 0, 0 ) ;
       }    
       
     Space[Pos-1] = 1 ;
     Round ++ ;
   }
   
}
